#! /bin/sh

#
# DO NOT COMMIT CHANGES TO THIS FILE WITHOUT CONSULTING EITHER
# meder@mcs.anl.gov or welch@mcs.anl.gov
#

USERHOME=$1
PORT=$2
USERNAME=$3
MASTERDN=$4
MASTERHOST=$5
MASTERPORT=$6

USER_ID=`/usr/bin/perl -e 'print scalar(getpwnam($ENV{"USER"}));'`
X509_USER_PROXY=/tmp/x509up_u${USER_ID}_grim
export X509_USER_PROXY

GLOBUSDIR=$USERHOME/.globus
USERDIR="${GLOBUSDIR}/uhe-`/bin/hostname`"
CLIENT_CONFIG=/opt/gt3/local-client-config.wsdd
LOG_CONFIG=/opt/gt3/log4j.properties
LOGFILE=log

umask 022

if [ ! -d $GLOBUSDIR ] ; then
    /bin/mkdir $GLOBUSDIR
fi

if [ ! -d $USERDIR ] ; then
    /bin/mkdir $USERDIR
fi

if [ ! -r $USERDIR/client-config.wsdd ] ; then
    /bin/cp $CLIENT_CONFIG $USERDIR/client-config.wsdd
fi

if [ ! -r $USERDIR/log4j.properties ] ; then
    /bin/cp $LOG_CONFIG $USERDIR
fi

if [ ! -r $USERDIR/schema ] ; then
    /bin/cp -rf /opt/gt3/schema $USERDIR
fi

DIRLIBS=/opt/gt3/lib/*.jar

CLASSPATH=/opt/gt3/build/classes
for i in ${DIRLIBS}
do
    # if the directory is empty, then it will return the input string
    # this is stupid, so case for it
    if [ "$i" != "${DIRLIBS}" ] ; then
        CLASSPATH=$i:$CLASSPATH
    fi
done

CLASSPATH=$USERDIR:$CLASSPATH
export CLASSPATH

cd $USERDIR

if [ -r $LOGFILE ] ; then
    /bin/mv $LOGFILE $LOGFILE.old
fi

exec /usr/java/j2sdk1.4.2_06/jre/bin/java -Djava.endorsed.dirs=/opt/gt3/endorsed -DX509_USER_PROXY=$X509_USER_PROXY -Dorg.globus.ogsa.server.webroot=/opt/gt3/ org.globus.ogsa.impl.base.gram.uhe.UserContainer /opt/gt3 "$USERNAME" "$MASTERDN" "$MASTERHOST" "$MASTERPORT" -lazy -p "$PORT" > $LOGFILE 2>&1
