create sequence jobManagerId_seq;

create table JobManagerStateTable
(
	jobManagerId int primary key default nextval('jobManagerId_seq'),
	jobManagerState int not null,
	jobManagerStatus int not null,
	jobManagerFailureCode text,
	jobId text,
	rsl text not null,
	cacheTag text,
	commitTimeout int,
	scratchDirectory text,
	credentialPath text not null
);


create table FileStreamTable
(
	streamType text not null,
	fileOffset int,
	fileStreamUrl text not null,
	jobManagerId int references JobManagerStateTable,
	primary key(fileStreamUrl, jobManagerId)
);


create table StagingTable
(
	srcURL text not null,
	destURL text not null,
	stagingType text not null,
	jobManagerId int references JobManagerStateTable,
	primary key(srcURL, destURL, jobManagerId)
);

	
