use Grid::GPT::Setup;
use Globus::Core::Paths;
use Getopt::Long;

# default values of config parameters
my $mmjfs_service_name   = 'MasterForkManagedJobFactoryService';
my $mjfs_service_name    = 'ForkManagedJobFactoryService';
my $gt3_location         = $ENV{GLOBUS_LOCATION};
my $package_name         = '';

GetOptions('master-service-name|m=s' => \$mmjfs_service_name,
           'service-name|s=s' => \$mjfs_service_name,
           'package-name|p=s' => \$package_name,
	   'help|h' => \$help);

&usage if ($help || $package_name eq '');

my $metadata =
    new Grid::GPT::Setup(package_name => $package_name);

my $globusdir	= $ENV{GLOBUS_LOCATION};

my @cmd = ('ant', '-f', "$ENV{GLOBUS_LOCATION}/etc/build-mmjfs-gar.xml",
   "-Dmmjfs.service.name=$mmjfs_service_name",
   "-Dmjfs.service.name=$mjfs_service_name",
   "-Dogsa.root=$gt3_location",
   "-Dabsolute.ogsa.root=$gt3_location",
   "deployGar");

$rc = system(@cmd);
if($? == 0)
{
    $metadata->finish();
}
else
{
    print STDERR "Error creating service entry $mjfs_name.\n";
}

sub usage
{
    print "Usage: $0 [options]\n".
	  "          [--help|-h]\n";
    exit 1;
}
