/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.guide.impl;

import org.globus.ogsa.guide.Counter.complex.ActionNotAllowedFaultType;
import org.globus.ogsa.guide.Counter.complex.ActionType;
import org.globus.ogsa.guide.Counter.complex.ComplexCounterPortType;
import org.globus.ogsa.guide.Counter.complex.TimestampedValue;
import org.globus.ogsa.guide.Counter.complex.service.ComplexCounterServiceGridLocator;
import org.globus.ogsa.utils.MessageUtils;

import org.gridforum.ogsi.HandleType;

import java.util.Calendar;


public class ComplexCounterClient {
    public static void main(String[] args) {
        if (args.length < 2) {
            System.err.println(
                MessageUtils.getMessage(
                    GuideConstants.GUIDE, "usage",
                    new String[] {
                        "ComplexCounterClient <handle> |add|subtract|get| |val|"
                    }
                )
            );

            return;
        }

        int val = 1;

        if (args.length > 2) {
            val = Integer.parseInt(args[2]);
        }

        try {
            ComplexCounterServiceGridLocator counterLocator =
                new ComplexCounterServiceGridLocator();
            ComplexCounterPortType counter =
                counterLocator.getComplexCounterPort(new HandleType(args[0]));
            ActionType action = null;
            TimestampedValue timestampedValue = new TimestampedValue();
            timestampedValue.setValue(val);
            timestampedValue.setTime(Calendar.getInstance());

            if (args[1].equalsIgnoreCase("add")) {
                action = ActionType.add;
            } else if (args[1].equalsIgnoreCase("subtract")) {
                action = ActionType.subtract;
            } else if (args[1].equalsIgnoreCase("get")) {
                action = ActionType.get;
            } else {
                throw new ActionNotAllowedFaultType();
            }

            System.out.println(
                MessageUtils.getMessage(GuideConstants.GUIDE, "value") +
                counter.submitAction(action, timestampedValue)
            );
        } catch (Exception e) {
            System.err.println(MessageUtils.toString(e));
        }
    }
}
