/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.guide.impl;

import org.globus.ogsa.impl.ogsi.GridServiceImpl;
import org.globus.ogsa.guide.Counter.complex.ActionNotAllowedFaultType;
import org.globus.ogsa.guide.Counter.complex.ActionType;
import org.globus.ogsa.guide.Counter.complex.ComplexCounterPortType;
import org.globus.ogsa.guide.Counter.complex.TimestampedValue;
import org.globus.ogsa.utils.MessageUtils;

import org.gridforum.ogsi.FaultType;

import java.rmi.RemoteException;


public class ComplexCounterImpl extends GridServiceImpl
    implements ComplexCounterPortType {
    private int val = 0;

    public ComplexCounterImpl() {
        super("Guide Complex Counter");
    }

    public int submitAction(
        ActionType action,
        TimestampedValue timestampedValue
    ) throws RemoteException, ActionNotAllowedFaultType, FaultType {
        if (action.equals(ActionType.add)) {
            val += timestampedValue.getValue();
        } else if (action.equals(ActionType.subtract)) {
            val -= timestampedValue.getValue();
        } else if (!action.equals(ActionType.get)) {
            throw new ActionNotAllowedFaultType();
        }

        System.out.println(
            MessageUtils.getMessage(GuideConstants.GUIDE, "timestamp") +
            timestampedValue.getTime().getTime()
        );

        return val;
    }
}
