/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.guide.impl;

import org.globus.ogsa.GridContext;
import org.globus.ogsa.GridServiceBase;
import org.globus.ogsa.GridServiceCallback;
import org.globus.ogsa.GridServiceException;
import org.globus.ogsa.OperationProvider;

import javax.xml.namespace.QName;

import java.rmi.RemoteException;


public class CounterProvider implements OperationProvider, GridServiceCallback {
    // Use the double wild card with care - all operations not in the OGSI 
    // namespace will be delegated to this class by default
    private static final QName[] operations =
        new QName[] { new QName("", "*") };
    private GridServiceBase base;
    private int val = 0;

    // Operation Provider methods
    public void initialize(GridServiceBase base) throws GridServiceException {
        this.base = base;
    }

    public QName[] getOperations() {
        return operations;
    }

    // Counter PortType methods
    public int add(int val) throws RemoteException {
        this.val = this.val + val;

        return this.val;
    }

    public int subtract(int val) throws RemoteException {
        this.val = this.val - val;

        return this.val;
    }

    public int getValue() throws RemoteException {
        return this.val;
    }

    // GridServiceCallback methods (optional)
    public void preCreate(GridServiceBase base) throws GridServiceException {
    }

    public void postCreate(GridContext context) throws GridServiceException {
    }

    public void activate(GridContext context) throws GridServiceException {
    }

    public void deactivate(GridContext context) throws GridServiceException {
    }

    public void preDestroy(GridContext context) throws GridServiceException {
    }
}
