/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.guide.impl;

import org.globus.ogsa.impl.ogsi.GridServiceImpl;
import org.globus.ogsa.GridContext;
import org.globus.ogsa.GridServiceException;
import org.globus.ogsa.ServiceData;
import org.globus.ogsa.guide.Counter.CounterPortType;
import org.globus.ogsa.utils.MessageUtils;

import java.rmi.RemoteException;


public class NotificationCounterImpl extends GridServiceImpl
    implements CounterPortType {
    private int val = 0;
    private ServiceData counterData;
    private String initializedStatus =
        MessageUtils.getMessage(GuideConstants.GUIDE, "initializedStatus");
    private String addStatus =
        MessageUtils.getMessage(GuideConstants.GUIDE, "addStatus");
    private String subtractStatus =
        MessageUtils.getMessage(GuideConstants.GUIDE, "subtractStatus");
    private String getValueStatus =
        MessageUtils.getMessage(GuideConstants.GUIDE, "getValueStatus");

    public NotificationCounterImpl() {
        super("Guide Notification Counter");
    }

    public void postCreate(GridContext context) throws GridServiceException {
	super.postCreate(context);
        counterData = this.serviceData.create("CounterStatus");
        counterData.setValue(initializedStatus);
        this.serviceData.add(counterData);
    }

    public int add(int val) throws RemoteException {
        counterData.setValue(addStatus);
        counterData.notifyChange();
        this.val = this.val + val;

        return this.val;
    }

    public int subtract(int val) throws RemoteException {
        counterData.setValue(subtractStatus);
        counterData.notifyChange();
        this.val = this.val - val;

        return this.val;
    }

    public int getValue() throws RemoteException {
        counterData.setValue(getValueStatus);
        counterData.notifyChange();

        return val;
    }
}
