#ifndef _GLOBUS_GSOAP_IO_PLUGIN_H_
#define _GLOBUS_GSOAP_IO_PLUGIN_H_

#ifndef EXTERN_C_BEGIN
#    ifdef __cplusplus
#        define EXTERN_C_BEGIN extern "C" {
#        define EXTERN_C_END }
#    else
#        define EXTERN_C_BEGIN
#        define EXTERN_C_END
#    endif
#endif

EXTERN_C_BEGIN

#include <stdsoap2.h>
#include <globus_io.h>

#define GLOBUS_GSOAP_IO_PLUGIN_ID  "globus_gsoap_io_plugin"

#define GLOBUS_GSOAP_IO_PLUGIN_MODULE (&globus_i_gsoap_io_plugin_module)

extern
globus_module_descriptor_t              globus_i_gsoap_io_plugin_module;

typedef struct globus_l_gsoap_io_plugin_handle_s *
                                        globus_gsoap_io_plugin_handle_t;

int
globus_gsoap_io_plugin_register(
    struct soap *                       soap,
    struct soap_plugin *                p,
    void *                              arg);

globus_result_t
globus_gsoap_io_plugin_create_listener(
    struct soap *                       soap,
    const char *                        hostname,
    int *                               port,
    int                                 backlog);

int
globus_gsoap_io_plugin_listen_accept(
    struct soap *                       soap);

globus_result_t
globus_gsoap_io_plugin_get_error(
    struct soap *                       soap);

globus_result_t
globus_gsoap_io_plugin_set_service_info(
    struct soap *                       soap,
    char *                              service_filename,
    char *                              service_url);

globus_result_t
globus_gsoap_io_plugin_is_http_method_get(
    struct soap *                       soap,
    int *                               http_method_get);

globus_result_t
globus_gsoap_io_plugin_set_handle(
    struct soap *                       soap,
    globus_io_handle_t *                handle);

EXTERN_C_END

#endif /* _GLOBUS_GSOAP_IO_PLUGIN_H_ */

