#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
/**
 * @file globus_ogsa_security_grim.h
 * Globus OGSA Security GRIM Verify Callbacks
 * @author Sam Lang
 *
 * $RCSfile: globus_ogsa_security_grim.h,v $
 * $Revision: 1.1.1.1 $
 * $Date: 2003/06/04 20:09:10 $
 */
#endif

#ifndef _GLOBUS_OGSA_SECURITY_GRIM_H_
#define _GLOBUS_OGSA_SECURITY_GRIM_H_

#include <globus_common.h>

EXTERN_C_BEGIN

#define GLOBUS_OGSA_SECURITY_GRIM_MODULE (&globus_i_ogsa_security_grim_module)

extern 
globus_module_descriptor_t              globus_i_ogsa_security_grim_module;

#include <xmlsec/keysmngr.h>
#include <xmlsec/keyinfo.h>
#include <xmlsec/keys.h>
#include <xmlsec/x509.h>

#include <openssl/x509.h>
#include <globus_gsi_credential.h>
#include <proxycertinfo.h>
#include <globus_grim_devel.h>

int
globus_ogsa_security_grim_verify(
    xmlSecKeysMngrPtr                   mngr,
    void *                              context,
    xmlSecX509DataPtr                   xmlSecCert);

int
globus_ogsa_security_grim_verify_null(
    xmlSecKeysMngrPtr                   mngr,
    void *                              context,
    xmlSecX509DataPtr                   cert);

int
globus_ogsa_security_grim_verify_full(
    xmlSecKeysMngrPtr                   mngr,
    void *                              context,
    xmlSecX509DataPtr                   cert);

globus_result_t
globus_ogsa_security_grim_setup_gss_context(
    gss_ctx_id_t *                      context);

#endif /* _GLOBUS_OGSA_SECURITY_GRIM_H_ */
