#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
/**
 * @file globus_ogsa_security_rsa_sha1.h
 * Globus OGSA Security RSA-SHA1 Library
 * @author Sam Lang
 *
 * $RCSfile: globus_ogsa_security_rsa_sha1.h,v $
 * $Revision: 1.1.1.1 $
 * $Date: 2003/06/04 20:09:16 $
 */
#endif

#ifndef _GLOBUS_OGSA_SECURITY_RSA_SHA1_H_
#define _GLOBUS_OGSA_SECURITY_RSA_SHA1_H_

#include <globus_common.h>
#include <stdsoap2.h>
#include <gssapi.h>
#include <globus_openssl.h>
#include <xmlsec/x509.h>

EXTERN_C_BEGIN

#define GLOBUS_OGSA_SECURITY_RSA_SHA1_ID "globus_ogsa_security_rsa_sha1"

#define GLOBUS_OGSA_SECURITY_RSA_SHA1_MODULE (&globus_l_ogsa_security_rsa_sha1_module)

extern
globus_module_descriptor_t              globus_l_ogsa_security_rsa_sha1_module;

typedef struct globus_l_ogsa_security_rsa_sha1_handle_s *
globus_ogsa_security_rsa_sha1_handle_t;

globus_result_t
globus_ogsa_security_rsa_sha1_handle_init(
    globus_ogsa_security_rsa_sha1_handle_t * handle,
    xmlSecX509VerifyCallback               verify_callback);

globus_result_t
globus_ogsa_security_rsa_sha1_handle_destroy(
    globus_ogsa_security_rsa_sha1_handle_t handle);

globus_result_t
globus_ogsa_security_rsa_sha1_sign(
    globus_ogsa_security_rsa_sha1_handle_t handle,
    char **                                buffer,
    size_t *                               buffer_length);

globus_result_t
globus_ogsa_security_rsa_sha1_sign_dom(
    globus_ogsa_security_rsa_sha1_handle_t handle,
    xmlDocPtr                              doc);

globus_result_t
globus_ogsa_security_rsa_sha1_verify(
    globus_ogsa_security_rsa_sha1_handle_t handle,
    char **                                buffer,
    size_t *                               buffer_length);

globus_result_t
globus_ogsa_security_rsa_sha1_verify_dom(
    globus_ogsa_security_rsa_sha1_handle_t handle,
    xmlDocPtr                              doc);

int
globus_ogsa_security_rsa_sha1_register(
    struct soap *                       soap,
    struct soap_plugin *                p,
    void *                              arg);    

EXTERN_C_END

#endif /* _GLOBUS_OGSA_GSOAP_WSSEC_PLUGIN_H_ */
