
#ifndef _GLOBUS_OGSI_CORE_H_
#define _GLOBUS_OGSI_CORE_H_

#include <globus_common.h>

EXTERN_C_BEGIN

#include <xmlsec/keysmngr.h>
#include <globus_ogsi_types.h>
#include <globus_ogsi_service_plugin.h>
#include <globus_ogsa_security_authentication.h>
#include <stdsoap2.h>

#define GLOBUS_OGSI_CORE_MODULE (&globus_i_ogsi_core_module)

extern
globus_module_descriptor_t              globus_i_ogsi_core_module;

globus_result_t
globus_ogsi_core_parse_service_reference(
    char *                              buffer,
    char **                             gsh);

globus_result_t
globus_ogsi_core_createService(
    const char *                        url,
    globus_abstime_t *                  terminate_before,
    globus_abstime_t *                  terminate_after,
    globus_ogsi_types_serializer_t      serviceParamsSerializer,
    globus_ogsi_types_free_buffer_t     serviceParamsFreeBuffer,
    void *                              serviceParameters,
    char **                             GSR,
    char **                             GSH,
    globus_abstime_t **                 goodFrom,
    globus_abstime_t **                 goodUntil,
    xmlSecX509VerifyCallback            verify_callback,
    int                                 secure);

globus_result_t
globus_ogsi_core_findServiceData(
    const char *                        GSH,
    struct Namespace  *                 namespaces,
    const char *                        sde_name,
    globus_ogsi_service_plugin_handle_attr_t service_attrs,
    globus_ogsa_security_auth_attr_t    security_attrs,
    int                                 confidential,
    globus_list_t **                    elements);

globus_result_t
globus_ogsi_core_setServiceData(
    const char *                        GSH,
    struct Namespace  *                 namespaces,
    globus_list_t *                     sdes,
    globus_ogsi_service_plugin_handle_attr_t service_attrs,
    globus_ogsa_security_auth_attr_t    security_attrs,
    int                                 confidential,
    globus_list_t **                    elements);

globus_result_t
globus_ogsi_core_destroy(
    const char *                        GSH,
    globus_ogsa_security_auth_attr_t    security_attrs,
    int                                 confidential);

globus_result_t
globus_ogsi_core_findByHandle(
    const char *                        GSH,
    char *                              handle,
    globus_ogsa_security_auth_attr_t    security_attrs,
    int                                 confidential,
    char **                             GSR);

globus_result_t
globus_ogsi_core_requestTerminationBefore(
    const char *                        GSH,
    globus_abstime_t *                  termTime,
    globus_ogsa_security_auth_attr_t    security_attrs,
    int                                 confidential,
    globus_abstime_t **                 before,
    globus_abstime_t **                 after,
    globus_abstime_t **                 timestamp);

globus_result_t
globus_ogsi_core_requestTerminationAfter(
    const char *                        GSH,
    globus_abstime_t *                  termTime,
    globus_ogsa_security_auth_attr_t    security_attrs,
    int                                 confidential,
    globus_abstime_t **                 before,
    globus_abstime_t **                 after,
    globus_abstime_t **                 timestamp);

EXTERN_C_END

#endif /* _GLOBUS_OGSI_CORE_H_ */
