#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
/**
 * @file globus_ogsi_types.h
 * Globus Core Types
 * @author Sam Lang
 *
 * $RCSfile $
 * $Revision $
 * $Date $
 */
#endif

#ifndef _GLOBUS_OGSI_NOTIFICATION_H_
#define _GLOBUS_OGSI_NOTIFICATION_H_

#include <globus_common.h>

EXTERN_C_BEGIN

#include <globus_ogsi_service_plugin.h>
#include <globus_ogsa_security_authentication.h>

#define GLOBUS_OGSI_NOTIFICATION_MODULE (&globus_ogsi_notification_module)

extern
globus_module_descriptor_t              globus_ogsi_notification_module;

typedef struct globus_ogsi_notification_listener_s *
                                        globus_ogsi_notification_listener_t;

typedef struct globus_ogsi_notification_sink_s *
                                        globus_ogsi_notification_sink_t;

typedef void (* globus_ogsi_notification_callback_t) (
    globus_ogsi_notification_sink_t     handle,
    globus_list_t *                     sde_list,
    void *                              callback_args);

globus_result_t
globus_ogsi_notification_listener_init(
    globus_ogsi_notification_listener_t * handle);

globus_result_t
globus_ogsi_notification_add_sink(
    globus_ogsi_notification_listener_t      handle,
    globus_ogsi_notification_callback_t      callback,
    void *                                   callback_args,
    globus_ogsi_service_plugin_handle_attr_t service_handle_attributes,
    globus_ogsa_security_auth_attr_t         security_attrs,
    int                                      confidentiality,
    char *                                   sde_name,
    globus_abstime_t                         expire,
    struct Namespace *                       namespaces,
    char **                                  sink_gsh);

globus_result_t
globus_ogsi_notification_remove_sink(
    globus_ogsi_notification_listener_t listener,
    char *                              sink_gsh);

globus_result_t
globus_ogsi_notification_listener_destroy(
    globus_ogsi_notification_listener_t   handle);

globus_result_t
globus_ogsi_notification_listener_register_serve(
    globus_ogsi_notification_listener_t handle);

globus_result_t
globus_ogsi_notification_listener_register_cancel(
    globus_ogsi_notification_listener_t handle);

globus_result_t
globus_ogsi_notification_subscribe(
    globus_ogsi_notification_listener_t handle,
    globus_ogsa_security_auth_attr_t    security_attributes,
    char *                              sink_gsh,
    char *                              source_gsh,
    char **                             subscription_gsh);

globus_result_t
globus_ogsi_notification_unsubscribe(
    globus_ogsi_notification_listener_t handle,
    globus_ogsa_security_auth_attr_t    security_attributes,
    char *                              sink_gsh);

globus_result_t
globus_ogsi_notification_sink_set_namespaces(
    globus_ogsi_notification_listener_t handle,
    char *                              sink_gsh,
    struct Namespace *                  namespaces);

globus_result_t
globus_ogsi_notification_sink_get_sink_handle(
    globus_ogsi_notification_sink_t     handle,
    char **                             gsh);

globus_result_t
globus_ogsi_notification_sink_get_source_handle(
    globus_ogsi_notification_sink_t     handle,
    char **                             gsh);

globus_result_t
globus_ogsi_notification_sink_get_subscription_handle(
    globus_ogsi_notification_sink_t     handle,
    char **                             gsh);

globus_result_t
globus_ogsi_notification_listener_get_sink(
    globus_ogsi_notification_listener_t handle,
    char *                              gsh,
    globus_ogsi_notification_sink_t *   sink);

globus_result_t
globus_ogsi_notification_listener_get_info(
    globus_ogsi_notification_listener_t listener,
    char **                             hostip,
    int *                               port);

EXTERN_C_END

#endif /* _GLOBUS_OGSI_NOTIFICATION_H_ */

