#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
/**
 * @file ogsa_impl_utils.h
 * OGSA Impl Utility Library
 * @author Sam Lang
 *
 * $RCSfile: ogsa_impl_utils.h,v $
 * $Revision: 1.7 $
 * $Date: 2003/01/31 23:49:55 $
 */
#endif

#ifndef _OGSA_IMPL_UTILS_H_
#define _OGSA_IMPL_UTILS_H_

#define XSD_NS_HREF                     "http://www.w3.org/2001/XMLSchema"
#define XSI_NS_HREF                     "http://www.w3.org/2001/XMLSchema-instance"
#define SOAPENV_NS_HREF                 "http://schemas.xmlsoap.org/soap/envelope/"
#define SOAPENC_NS_HREF                 "http://schemas.xmlsoap.org/soap/encoding/"

#include <stdarg.h>
#include <string.h>
#include <stdsoap2.h>
#include <globus_gsoap_io_plugin.h>
#include <globus_io.h>
#include <libxml/tree.h>

EXTERN_C_BEGIN

#define OGSA_IMPL_UTILS_MODULE  (&ogsa_i_impl_utils_module)

extern
globus_module_descriptor_t              ogsa_i_impl_utils_module;

globus_result_t
ogsa_impl_utils_soap_error_result(
    int                                 soap_error);

globus_result_t
ogsa_impl_utils_dump_http_post(
    const char *                        orig_buffer,
    size_t                              length,
    xmlDocPtr                           doc,
    unsigned char **                    result_buffer,
    size_t *                            result_length);

globus_result_t
ogsa_impl_utils_parse_http_post(
    const char *                        buffer,
    size_t                              length,
    xmlDocPtr *                         xmlDoc);

globus_result_t
ogsa_impl_utils_soap_fault(
    xmlDocPtr                           doc);

globus_result_t
ogsa_impl_utils_setup_gsoap(
    struct soap *                       soap,
    char *                              url);

globus_result_t
ogsa_impl_utils_split_url(
    char *                              url,
    char **                             hostname,
    int *                               port,
    char **                             path);

globus_result_t
ogsa_impl_utils_check_httpg(
    char *                              url);

char *
ogsa_impl_utils_v_create_string(
    const char *                        format,
    va_list                             ap);

char *
ogsa_impl_utils_create_string(
    const char *                        format,
    ...);

char *
ogsa_impl_utils_v_create_nstring(
    size_t                              length,
    const char *                        format,
    va_list                             ap);

char *
ogsa_impl_utils_create_nstring(
    size_t                              length,
    const char *                        format,
    ...);

globus_result_t
ogsa_impl_utils_base64_encode(
    unsigned char *                     input_buffer,
    int                                 input_length,
    unsigned char **                    output_buffer);

globus_result_t
ogsa_impl_utils_base64_decode(
    unsigned char *                     input_buffer,
    unsigned char **                    output_buffer,
    int *                               output_length);

globus_result_t
ogsa_impl_utils_generate_uuid(
    char **                             uuid);

int
ogsa_impl_utils_soap_serve_operation(
    struct soap *                       soap,
    int                                 (* serve_op)(struct soap *));

int
ogsa_impl_utils_soap_serve_operations_list(
    struct soap *                       soap,
    globus_list_t *                     serve_ops);

globus_result_t
ogsa_impl_utils_gsoap_remove_plugin(
    struct soap *                       soap,
    char *                              id);

EXTERN_C_END

#endif
