<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text" indent="yes"/>
<xsl:template match="soapenv:Envelope" xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/">
<xsl:apply-templates select="soapenv:Body"/>
</xsl:template>
<xsl:template match="soapenv:Body" xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ns0="http://ogsa.gridforum.org/service/grid_service">
  <xsl:apply-templates select="ns0:findServiceDataResponse" />
</xsl:template>
<xsl:template match="ns0:findServiceDataResponse" xmlns:ns0="http://ogsa.gridforum.org/service/grid_service" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI">
 <xsl:apply-templates select="foo:result"/>
</xsl:template>
<xsl:template match="foo:result" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI" xmlns:ns3="http://www.gridforum.org/namespaces/2003/03/serviceData">
	<xsl:apply-templates select="ns3:serviceDataValues"/>
</xsl:template>
<xsl:template match="ns3:serviceDataValues" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1" xmlns:ns3="http://www.gridforum.org/namespaces/2003/03/serviceData">
<xsl:apply-templates select="glue:Cluster"/>
</xsl:template>
<xsl:template match="glue:Glue" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI">
   <xsl:apply-templates select="glue:Cluster"/>
</xsl:template>
<xsl:template match="glue:Cluster" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI">
   <xsl:apply-templates select="glue:SubCluster"/>
</xsl:template>
<xsl:template match="glue:SubCluster" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">
    <xsl:apply-templates select="glue:Host"/>
</xsl:template>
<xsl:template match="glue:Host" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">      
<xsl:variable name="name" select="@glue:Name" />
Host :                         <xsl:value-of select="@glue:Name" />
    <xsl:apply-templates select="glue:OperatingSystem" />
 
    <xsl:apply-templates select="glue:ApplicationSoftware" />

    <xsl:apply-templates select="glue:MainMemory" />

Network Adapter:   <xsl:apply-templates select="glue:NetworkAdapter" />

Processor: <xsl:apply-templates select="glue:Processor" />

Processor Load: <xsl:apply-templates select="glue:ProcessorLoad" />

File System: <xsl:apply-templates select="glue:FileSystem" />
        
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
</xsl:template>

<xsl:template match="glue:OperatingSystem" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">

OS:
 -Name                         <xsl:value-of select="@glue:Name" />
 -Version                      <xsl:value-of select="@glue:Release" />

</xsl:template>
<xsl:template match="glue:ApplicationSoftware" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">
<xsl:apply-templates select="glue:RunTimeEnvironment" />
</xsl:template>
<xsl:template match="glue:RunTimeEnvironment" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">

Application Software:
 -Name                         <xsl:value-of select="@glue:Name" />

</xsl:template>
<xsl:template match="glue:MainMemory" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">

Main Memory:
 -RAM Available                <xsl:value-of select="@glue:RAMAvailable" /> of <xsl:value-of select="@glue:RAMSize" />
 -Virtual Available            <xsl:value-of select="@glue:VirtualAvailable" /> of <xsl:value-of select="@glue:VirtualSize" />

 </xsl:template>
<xsl:template match="glue:NetworkAdapter" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">

 -IPAddress                    <xsl:value-of select="@glue:IPAddress"/> 
 -MTU                          <xsl:value-of select="@glue:MTU"/>
 -Name                         <xsl:value-of select="@glue:Name" />
</xsl:template>
<xsl:template match="glue:Processor" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">
 -Cache                        <xsl:value-of select="@glue:CacheL2" />
 -ClockSpeed                   <xsl:value-of select="@glue:ClockSpeed" />
 -Model                       <xsl:value-of select="@glue:Model" />
 -Description                  <xsl:value-of select="@glue:OtherProcessorDescription" />
 -Vendor                      <xsl:value-of select="@glue:Vendor" />
 -Version                      <xsl:value-of select="@glue:Version" />
</xsl:template>
<xsl:template match="glue:ProcessorLoad" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">
 -Last15Minutes                <xsl:value-of select="@glue:Last15Min" />
 -Last1Minute                  <xsl:value-of select="@glue:Last1Min"  /> 
 -Last5Minutes                 <xsl:value-of select="@glue:Last5Min" />
</xsl:template>
<xsl:template match="glue:FileSystem" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1">
 
 -Availble Space               <xsl:value-of select="@glue:AvailableSpace" />
 -Name                         <xsl:value-of select="@glue:Name" />
 -Read-Only                    <xsl:value-of select="@glue:ReadOnly" />
 -Root                         <xsl:value-of select="@glue:Root" />
 -Size                         <xsl:value-of select="@glue:Size" /> 
 -Type                         <xsl:value-of select="@glue:Type" />
     
</xsl:template>

</xsl:stylesheet>
