<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:output method="text" indent="yes"/>

<xsl:template match="soapenv:Envelope" xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/">

<xsl:apply-templates select="soapenv:Body"/>

</xsl:template>

<xsl:template match="soapenv:Body" xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ns0="http://ogsa.gridforum.org/service/grid_service">

  <xsl:apply-templates select="ns0:findServiceDataResponse" />

</xsl:template>

<xsl:template match="ns0:findServiceDataResponse" xmlns:ns0="http://ogsa.gridforum.org/service/grid_service" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI">

  <xsl:apply-templates select="foo:result"/>

</xsl:template>
<xsl:template match="foo:result" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI" xmlns:ns3="http://www.gridforum.org/namespaces/2003/03/serviceData">

	<xsl:apply-templates select="ns3:serviceDataValues"/>

</xsl:template>
<xsl:template match="ns3:serviceDataValues" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1" xmlns:ns3="http://www.gridforum.org/namespaces/2003/03/serviceData">

<xsl:apply-templates select="foo:terminationTime"/>
<xsl:apply-templates select="foo:interface"/>
<xsl:apply-templates select="foo:serviceDataName"/>
.
</xsl:template>


<xsl:template match="foo:terminationTime" xmlns:glue="http://glue.base.ogsa.globus.org/ce/1.1" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI">

TerminationTime:  <xsl:value-of select="@foo:timestamp" />.
</xsl:template>

<xsl:template match="foo:interface" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI" >
PortType:  <xsl:value-of select="." />. 
</xsl:template>

<xsl:template match="foo:serviceDataName" xmlns:foo="http://www.gridforum.org/namespaces/2003/03/OGSI" >
SDE     :  <xsl:value-of select="." />. 
</xsl:template>

</xsl:stylesheet>
