/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.gui;

import org.globus.ogsa.impl.core.handle.HandleHelper;
import org.globus.ogsa.wsdl.GSR;
import org.globus.ogsa.utils.MessageUtils;

import org.gridforum.ogsi.HandleType;
import org.gridforum.ogsi.FaultType;

import javax.swing.BorderFactory;
import javax.swing.JPanel;

import java.net.URL;


public class AbstractPortTypePanel extends JPanel implements ServiceInterface {
    protected ServiceContext context;
    protected URL handle;
    protected URL defaultEndpoint;
    protected GSR gsr;

    public AbstractPortTypePanel(String title) {
        setBorder(BorderFactory.createTitledBorder(title));
    }

    public void setHandle(URL handle) {
        this.handle = handle;
    }

    public void setGSR(GSR gsr) throws Exception {
        this.gsr = gsr;
        this.defaultEndpoint = new URL(gsr.getEndpoint());
    }

    public void refreshGSR() throws Exception {
        setGSR(HandleHelper.getGSR(new HandleType(this.handle.toString())));
    }

    public void setContext(ServiceContext context) {
        this.context = context;
    }

    public void init() {
    }

    public void dispose() {
    }

    public String getErrorMessage(Exception e) {
	return MessageUtils.getErrorMessage(e);
    }
    
}
