/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.gui;

import org.apache.axis.description.OperationDesc;

import javax.swing.BoxLayout;
import javax.swing.JPanel;

import java.util.Collection;
import java.util.Iterator;


public class DynamicServicePanel extends JPanel implements OperationListener {
    public DynamicServicePanel(
        String gsh,
        Collection operationDescs
    ) {
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        Iterator operationDescIterator = operationDescs.iterator();

        while (operationDescIterator.hasNext()) {
            OperationDesc operationDesc =
                (OperationDesc) operationDescIterator.next();

            DynamicOperationPanel operationPanel =
                new DynamicOperationPanel(gsh, operationDesc);

            operationPanel.addOperationListener(this);

            add(operationPanel);
        }
    }

    /*
    public void operationFinished(  OperationDesc operationDesc,
                                    Object result,
                                    Class returnType ) {
                                    */
    public void operationFinished(
        OperationDesc operationDesc,
        Object result
    ) {
    }
}
