/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.gui;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class SecureContextEstablishmentPortTypePanel
    extends AbstractPortTypePanel {
    public SecureContextEstablishmentPortTypePanel() {
        super(" Authentication ");

        ButtonGroup buttonGroup = new ButtonGroup();
        JRadioButton signatureRB = new JRadioButton("XML Signature");
        JRadioButton encryptionRB = new JRadioButton("XML Encryption");
        JRadioButton disableRB = new JRadioButton("None");

        buttonGroup.add(disableRB);
        buttonGroup.add(signatureRB);
        buttonGroup.add(encryptionRB);

        ButtonGroup delegGroup = new ButtonGroup();
        JRadioButton noDelegationRB = new JRadioButton("None");
        JRadioButton limitedDelegationRB = new JRadioButton("Limited");
        JRadioButton fullDelegationRB = new JRadioButton("Full");

        delegGroup.add(noDelegationRB);
        delegGroup.add(limitedDelegationRB);
        delegGroup.add(fullDelegationRB);

        signatureRB.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    context.setAuthentication(ServiceContext.XML_SIGNATURE);
                }
            }
        );
        encryptionRB.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    context.setAuthentication(ServiceContext.XML_ENCRYPTION);
                }
            }
        );
        disableRB.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    context.setAuthentication(ServiceContext.NO_AUTHENTICATION);
                }
            }
        );

        limitedDelegationRB.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    context.setDelegation(ServiceContext.LIMITED_DELEGATION);
                }
            }
        );

        fullDelegationRB.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    context.setDelegation(ServiceContext.FULL_DELEGATION);
                }
            }
        );

        noDelegationRB.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    context.setDelegation(ServiceContext.NO_DELEGATION);
                }
            }
        );

        JPanel panel = new JPanel();
        panel.add(new JLabel("Message Protection: "));
        panel.add(disableRB);
        panel.add(signatureRB);
        panel.add(encryptionRB);

        panel.add(new JLabel("Delegation: "));
        panel.add(noDelegationRB);
        panel.add(limitedDelegationRB);
        panel.add(fullDelegationRB);

        setLayout(new FlowLayout());
        disableRB.setSelected(true);
        noDelegationRB.setSelected(true);
        add(panel);
    }

    public void init() {
    }

    public void dispose() {
    }
}
