/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.gui;

import org.globus.ogsa.samples.weather.WeatherPortType;
import org.globus.ogsa.samples.weather.service.WeatherServiceLocator;
import org.globus.ogsa.utils.GSIUtils;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import javax.xml.rpc.Stub;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class WeatherPortTypePanel extends AbstractPortTypePanel {
    private JTextField zipCodeTF;
    private JLabel tempLB;

    public WeatherPortTypePanel() {
        super(" Weather Example ");

        this.zipCodeTF = new JTextField(10);

        JButton setBT = new JButton("Set");

        setBT.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    setZip();
                }
            }
        );

        JPanel setZipPanel = new JPanel();
        setZipPanel.add(new JLabel("Zip code: "));
        setZipPanel.add(this.zipCodeTF);
        setZipPanel.add(setBT);

        this.tempLB = new JLabel("            ");

        JButton getBT = new JButton("Update");

        getBT.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    getTemp();
                }
            }
        );

        JPanel tempPanel = new JPanel();
        tempPanel.add(new JLabel("Temperature: "));
        tempPanel.add(this.tempLB);
        tempPanel.add(getBT);

        setLayout(new BorderLayout());
        add(setZipPanel, BorderLayout.NORTH);
        add(tempPanel, BorderLayout.CENTER);
    }

    private void setZip() {
        if ((this.context == null) || (this.defaultEndpoint == null)) {
            // TODO: defaultEndpoint error
            return;
        }

        String zipCode = this.zipCodeTF.getText();

        WeatherServiceLocator weatherService = new WeatherServiceLocator();

        try {
            WeatherPortType weather =
                weatherService.getWeatherPort(this.defaultEndpoint);

            GSIUtils.setDefaultGSIProperties(
                (Stub) weather, this.defaultEndpoint
            );

            float temp = weather.setZipCode(zipCode);
            this.tempLB.setText(String.valueOf(temp));
        } catch (Exception e) {
            JOptionPane.showMessageDialog(
                this, "Failed to set zip code: " + e.getMessage(),
                "Weather: set zip code error", JOptionPane.ERROR_MESSAGE
            );
            e.printStackTrace();

            return;
        }
    }

    private void getTemp() {
        if ((this.context == null) || (this.defaultEndpoint == null)) {
            // TODO: defaultEndpoint error
            return;
        }

        WeatherServiceLocator weatherService = new WeatherServiceLocator();

        try {
            WeatherPortType weather =
                weatherService.getWeatherPort(this.defaultEndpoint);

            GSIUtils.setDefaultGSIProperties(
                (Stub) weather, this.defaultEndpoint
            );

            float temp = weather.getTemp();

            this.tempLB.setText(String.valueOf(temp));
        } catch (Exception e) {
            JOptionPane.showMessageDialog(
                this, "Failed to get temp.: " + e.getMessage(),
                "Weather: get temp. error", JOptionPane.ERROR_MESSAGE
            );
            e.printStackTrace();

            return;
        }
    }
}
