/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.impl.samples.any;

import org.globus.ogsa.impl.ogsi.GridServiceImpl;
import org.globus.ogsa.GridContext;
import org.globus.ogsa.GridServiceException;
import org.globus.ogsa.ServiceProperties;
import org.globus.ogsa.utils.AnyHelper;
import org.globus.ogsa.utils.XmlFactory;

import org.gridforum.ogsi.ExtensibilityType;
import org.gridforum.ogsi.holders.ExtensibilityTypeHolder;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.w3c.dom.Element;
import org.w3c.dom.Document;

import java.rmi.RemoteException;

public class CreationImpl extends GridServiceImpl {

    public CreationImpl() {
        super("Any Creation Test");
    }

    public void postCreate(GridContext context) throws GridServiceException {
	super.postCreate(context);

	ExtensibilityType in = 
	    (ExtensibilityType)getProperty(ServiceProperties.CREATION_EXTENSIBILITY);

	if (in == null) {
	    throw new GridServiceException("No creation extensibility parameter");
	}

	Element elem = AnyHelper.getAsSingleElement(in);

	if (elem == null) {
	    throw new GridServiceException("Extensibility parameter is empty");
	}

	String param = elem.getAttribute("testParam");
	if (!param.equals("param1")) {
	    throw new GridServiceException("Invalid parameter");
	}
	
	ExtensibilityTypeHolder out = 
	    (ExtensibilityTypeHolder)getProperty(ServiceProperties.CREATION_EXTENSIBILITY_OUTPUT);
	
	if (out == null) {
	    throw new GridServiceException("No creation extensiblity return parameter");
	}

	Document doc = null;
	try {
	    doc = XmlFactory.newDocument();
	} catch (Exception e) {
	    throw new GridServiceException(e);
	}
	Element root = doc.createElement("testRetrunElement");
	root.setAttribute("testReturnParam", "param2");
	out.value = AnyHelper.getExtensibility(root);
    }
    
}
