/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.impl.samples.counter.client;

import org.globus.ogsa.samples.counter.CounterPortType;
import org.globus.ogsa.samples.counter.service.CounterServiceGridLocator;
import org.globus.ogsa.utils.GetOpts;
import org.globus.ogsa.utils.MessageUtils;

import org.gridforum.ogsi.HandleType;

import javax.xml.rpc.Stub;

public class GetValue {
    public static void main(String[] args) {
        CounterServiceGridLocator locator = new CounterServiceGridLocator();

        GetOpts opts =
            new GetOpts("Usage: GetValue [options] <service handle>", 1);
        String error = opts.parse(args);

        if (error != null) {
            System.err.println(error);

            return;
        }

        try {
            CounterPortType counter =
                locator.getCounterPort(new HandleType(opts.getArg(1)));
            opts.setOptions(((Stub) counter));

            int val = counter.getValue();
            System.out.println("Counter Value:" + val);
        } catch (Exception e) {
	    if (opts.isDebug()) {
		System.err.println(MessageUtils.toString(e));
	    } else {
		System.err.println("Error: " + opts.getErrorMessage(e));
	    }
        }
    }
}
