/*
This file is licensed under the terms of the Globus Toolkit Public
License, found at http://www.globus.org/toolkit/download/license.html.
*/
package org.globus.ogsa.impl.samples.counter.notification;

import org.globus.ogsa.impl.ogsi.GridServiceImpl;

import org.globus.ogsa.GridContext;
import org.globus.ogsa.ServiceData;
import org.globus.ogsa.GridServiceException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import javax.xml.namespace.QName;

import java.rmi.RemoteException;

public class CounterNotificationImpl extends GridServiceImpl {

    private static final QName COUNTER_SDE_NAME =
	new QName("http://samples.globus.org/extension/counter", 
		  "CounterUpdate");
    
    private ServiceData counterValueSDE;
    private int val = 0;
    
    public CounterNotificationImpl() {
        super("Sample Notification Counter");
    }

    public void postCreate(GridContext context) throws GridServiceException {
	super.postCreate(context);
	
	this.counterValueSDE = 
            this.serviceData.create(COUNTER_SDE_NAME);
	this.serviceData.add(this.counterValueSDE);
	this.counterValueSDE.setValue(new Integer(0));
    }

    public int add(int val) throws RemoteException {
        this.val += val;
        notifyUpdate();
        return this.val;
    }

    public int subtract(int val) throws RemoteException {
        this.val -= val;
        notifyUpdate();
        return this.val;
    }

    private void notifyUpdate() {
	this.counterValueSDE.setValue(new Integer(this.val));
	this.counterValueSDE.notifyChange();
    }

    public int getValue() throws RemoteException {
        return this.val;
    }
}
