# Allow the flavor name to be overideden by the user
my $globus_flavor_name = shift;

my $gpath = $ENV{GPT_LOCATION};
if (!defined($gpath))
{
  $gpath = $ENV{GLOBUS_LOCATION};

}
if (!defined($gpath))
{
   die "GPT_LOCATION or GLOBUS_LOCATION needs to be set before running this script"
}

@INC = (@INC, "$gpath/lib/perl");

require Grid::GPT::Setup;
my $metadata = new Grid::GPT::Setup(package_name => "gt3_hostinfo");

my $globusdir = $ENV{GLOBUS_LOCATION};

my $gt3dir = "$globusdir";
my $setupdir = "$globusdir/setup/globus/";
my $vardir = "$gt3dir/var/";
my $libexecdir = "$gt3dir/libexec";
my $etcdir = "$globusdir/etc/";

my $result = `$setupdir/setup-gt3-hostinfo-scripts --with-flavor=$globus_flavor_name`;

if (! -d "$gt3dir")
{
	$result = system("mkdir $gt3dir");
}

print "\nCreating directories...\n";
if (! -d "$vardir")
{
	$result = system("mkdir $vardir");
}
if (! -d "$libexecdir")
{
	$result = system("mkdir $libexecdir");
}

print "\nCreating...\n";

print "	$libexecdir/grid-hostinfo-script-initializer\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-script-initializer");
$result = system("cp grid-hostinfo-script-initializer $libexecdir");

print "	$libexecdir/grid-hostinfo-common\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-common");                                 
$result = system("cp grid-hostinfo-common $libexecdir");  

print "	$libexecdir/grid-hostinfo-cpu*\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-cpu*");                                 
$result = system("cp grid-hostinfo-cpu* $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-cpu*.in");

print "	$libexecdir/grid-hostinfo-fs*\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-fs*");                                 
$result = system("cp grid-hostinfo-fs* $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-fs*.in");

print "	$libexecdir/grid-hostinfo-mem*\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-mem*");                                 
$result = system("cp grid-hostinfo-mem* $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-mem*.in");

print "	$libexecdir/grid-hostinfo-net*\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-net*");                                 
$result = system("cp grid-hostinfo-net* $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-net*.in");

print "	$libexecdir/grid-hostinfo-platform*\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-platform*");                                 
$result = system("cp grid-hostinfo-platform* $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-platform*.in");

print "	$libexecdir/grid-hostinfo-os*\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-os*");                                 
$result = system("cp grid-hostinfo-os* $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-os*.in");

print "	$libexecdir/grid-hostinfo-partial-host\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-partial-host");                                 
$result = system("cp grid-hostinfo-partial-host $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-partial-host.in");

print "	$libexecdir/grid-hostinfo-partial-subcluster\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-partial-subcluster");                                 
$result = system("cp grid-hostinfo-partial-subcluster $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-partial-subcluster.in");

print "	$libexecdir/grid-hostinfo-partial-cluster\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-partial-cluster");                                 
$result = system("cp grid-hostinfo-partial-cluster $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-partial-cluster.in");

print "	$libexecdir/grid-hostinfo-runtime\n";
$result = system("chmod 0755 $setupdir/grid-hostinfo-runtime");                                 
$result = system("cp grid-hostinfo-runtime $libexecdir");  
$result = system("rm -f $libexecdir/grid-hostinfo-runtime.in");


print "	$etcdir/globus-host-providers.conf\n";
$result = system("chmod 0644 $setupdir/globus-host-providers.conf");
$result = system("cp globus-host-providers.conf $etcdir");  

$result = system("cp grid-hostinfo-soft-* $libexecdir");  
$result = system("chmod 0755 $libexecdir/grid-hostinfo-soft-*"); 

$result = system("cp grid-hostinfo-soft.conf $etcdir");  

print "Done\n";
$metadata->finish();
