use Grid::GPT::Setup;
use Getopt::Long;
use File::Copy;

GetOptions('help|h' => \$help);

&usage if $help;

my $metadata = new Grid::GPT::Setup(package_name => "globus_mmjfs_setup");

chdir( $ENV{'GLOBUS_LOCATION/gars'} );
print `ant -f $ENV{'GLOBUS_LOCATION'}/build.xml deploy -Dgar.name=$ENV{'GLOBUS_LOCATION'}/gars/mmjfs.gar`;
print `rm -f $ENV{'GLOBUS_LOCATION'}/bin/launch_uhe_setuid.c $ENV{'GLOBUS_LOCATION'}/bin/launch_uhe.sh  $ENV{'GLOBUS_LOCATION'}/bin/setperms.sh`;
print `cp $ENV{'GLOBUS_LOCATION'}/etc/launch_uhe_setuid.c.in $ENV{'GLOBUS_LOCATION'}/etc/launch_uhe.sh.in $ENV{'GLOBUS_LOCATION'}/bin`;
print `ant -f $ENV{'GLOBUS_LOCATION'}/gars/build-setuid.xml -Dogsa.root=$ENV{'GLOBUS_LOCATION'} -Dabsolute.ogsa.root=$ENV{'GLOBUS_LOCATION'} deploy`;
print `rm -f $ENV{'GLOBUS_LOCATION'}/bin/launch_uhe_setuid.c.in $ENV{'GLOBUS_LOCATION'}/bin/launch_uhe.sh.in`;

if ($? == 0) {
    $metadata->finish();
    exit 0;
}

print STDERR "Error configuring mmjfs\n";
exit 1;

sub usage
{
    print "Usage: $0 [options]\n".
          "Options:  [--help|-h]\n";
    exit 1;
}
